#ifndef SI3217X_REVC_REGS_H
#define SI3217X_REVC_REGS_H


/*
** SI3217X RevC Unique SPI Registers
*/
enum SI3217X_REVC_REG {
SI3217X_REVC_REG_DIAG3                   = 74,
SI3217X_REVC_REG_PCLK_FAULT_CNTL         = 76,
};

/*
** SI3217X_REVC_RAM
*/
enum SI3217X_REVC_RAM {
SI3217X_REVC_RAM_INIT_GUESS              = 15,
SI3217X_REVC_RAM_Y1                      = 16,
SI3217X_REVC_RAM_Y2                      = 17,
SI3217X_REVC_RAM_Y3                      = 18,
SI3217X_REVC_RAM_UNUSED19                = 19,
SI3217X_REVC_RAM_METER_LPF_OUT           = 328,
SI3217X_REVC_RAM_UNUSED333               = 333,
SI3217X_REVC_RAM_UNUSED334               = 334,
SI3217X_REVC_RAM_I_SOURCE1               = 385,
SI3217X_REVC_RAM_I_SOURCE2               = 386,
SI3217X_REVC_RAM_VTR1                    = 387,
SI3217X_REVC_RAM_VTR2                    = 388,
SI3217X_REVC_RAM_STOP_TIMER1             = 389,
SI3217X_REVC_RAM_STOP_TIMER2             = 390,
SI3217X_REVC_RAM_UNUSED391               = 391,
SI3217X_REVC_RAM_UNUSED392               = 392,
SI3217X_REVC_RAM_UNUSED416               = 416,
SI3217X_REVC_RAM_UNUSED443               = 443,
SI3217X_REVC_RAM_UNUSED459               = 459,
SI3217X_REVC_RAM_UNUSED487               = 487,
SI3217X_REVC_RAM_UNUSED488               = 488,
SI3217X_REVC_RAM_UNUSED489               = 489,
SI3217X_REVC_RAM_UNUSED490               = 490,
SI3217X_REVC_RAM_UNUSED491               = 491,
SI3217X_REVC_RAM_CAL_TEMP11              = 501,
SI3217X_REVC_RAM_METER_RAMP              = 502,
SI3217X_REVC_RAM_METER_RAMP_DIR          = 503,
SI3217X_REVC_RAM_METER_ON_T              = 504,
SI3217X_REVC_RAM_METER_PK_DET            = 505,
SI3217X_REVC_RAM_METER_PK_DET_T          = 506,
SI3217X_REVC_RAM_THERM_CNT               = 507,
SI3217X_REVC_RAM_VDIFF_SENSE_DELAY       = 508,
SI3217X_REVC_RAM_RING_INTERP_DIFF_SYNC   = 509,
SI3217X_REVC_RAM_CPUMP_DEB_CNT           = 510,
SI3217X_REVC_RAM_UNUSED757               = 757,
SI3217X_REVC_RAM_UNUSED758               = 758,
SI3217X_REVC_RAM_UNUSED760               = 760,
SI3217X_REVC_RAM_UNUSED761               = 761,
SI3217X_REVC_RAM_UNUSED762               = 762,
SI3217X_REVC_RAM_UNUSED763               = 763,
SI3217X_REVC_RAM_UNUSED778               = 778,
SI3217X_REVC_RAM_UNUSED779               = 779,
SI3217X_REVC_RAM_UNUSED792               = 792,
SI3217X_REVC_RAM_UNUSED793               = 793,
SI3217X_REVC_RAM_UNUSED794               = 794,
SI3217X_REVC_RAM_UNUSED795               = 795,
SI3217X_REVC_RAM_UNUSED796               = 796,
SI3217X_REVC_RAM_UNUSED797               = 797,
SI3217X_REVC_RAM_UNUSED798               = 798,
SI3217X_REVC_RAM_UNUSED799               = 799,
SI3217X_REVC_RAM_UNUSED800               = 800,
SI3217X_REVC_RAM_UNUSED870               = 870,
SI3217X_REVC_RAM_UNUSED872               = 872,
SI3217X_REVC_RAM_UNUSED873               = 873,
SI3217X_REVC_RAM_UNUSED885               = 885,
SI3217X_REVC_RAM_MADC_VBAT_SCALE         = 886,
SI3217X_REVC_RAM_UNUSED892               = 892,
SI3217X_REVC_RAM_UNUSED911               = 911,
SI3217X_REVC_RAM_UNUSED921               = 921,
SI3217X_REVC_RAM_UNUSED922               = 922,
SI3217X_REVC_RAM_UNUSED923               = 923,
SI3217X_REVC_RAM_UNUSED924               = 924,
SI3217X_REVC_RAM_UNUSED925               = 925,
SI3217X_REVC_RAM_UNUSED926               = 926,
SI3217X_REVC_RAM_UNUSED928               = 928,
SI3217X_REVC_RAM_METER_GAIN              = 961,
SI3217X_REVC_RAM_METER_GAIN_TEMP         = 968,
SI3217X_REVC_RAM_METER_RAMP_STEP         = 969,
SI3217X_REVC_RAM_THERM_DBI               = 970,
SI3217X_REVC_RAM_LPR_SCALE               = 971,
SI3217X_REVC_RAM_LPR_CM_OS               = 972,
SI3217X_REVC_RAM_VOV_DCDC_SLOPE          = 973,
SI3217X_REVC_RAM_VOV_DCDC_OS             = 974,
SI3217X_REVC_RAM_VOV_RING_BAT_MAX        = 975,
SI3217X_REVC_RAM_SLOPE_VLIM1             = 976,
SI3217X_REVC_RAM_SLOPE_RFEED1            = 977,
SI3217X_REVC_RAM_SLOPE_ILIM1             = 978,
SI3217X_REVC_RAM_V_VLIM1                 = 979,
SI3217X_REVC_RAM_V_RFEED1                = 980,
SI3217X_REVC_RAM_V_ILIM1                 = 981,
SI3217X_REVC_RAM_CONST_RFEED1            = 982,
SI3217X_REVC_RAM_CONST_ILIM1             = 983,
SI3217X_REVC_RAM_I_VLIM1                 = 984,
SI3217X_REVC_RAM_SLOPE_VLIM2             = 985,
SI3217X_REVC_RAM_SLOPE_RFEED2            = 986,
SI3217X_REVC_RAM_SLOPE_ILIM2             = 987,
SI3217X_REVC_RAM_V_VLIM2                 = 988,
SI3217X_REVC_RAM_V_RFEED2                = 989,
SI3217X_REVC_RAM_V_ILIM2                 = 990,
SI3217X_REVC_RAM_CONST_RFEED2            = 991,
SI3217X_REVC_RAM_CONST_ILIM2             = 992,
SI3217X_REVC_RAM_I_VLIM2                 = 993,
SI3217X_REVC_RAM_DIAG_V_TAR              = 994,
SI3217X_REVC_RAM_DIAG_V_TAR2             = 995,
SI3217X_REVC_RAM_STOP_TIMER1_VAL         = 996,
SI3217X_REVC_RAM_STOP_TIMER2_VAL         = 997,
SI3217X_REVC_RAM_DIAG_VCM1_TAR           = 998,
SI3217X_REVC_RAM_DIAG_VCM_STEP           = 999,
SI3217X_REVC_RAM_LKG_DNT_HIRES           = 1000,
SI3217X_REVC_RAM_LKG_DNR_HIRES           = 1001,
SI3217X_REVC_RAM_LINEAR_OS               = 1002,
SI3217X_REVC_RAM_CPUMP_DEB               = 1003,
SI3217X_REVC_RAM_DCDC_VERR               = 1004,
SI3217X_REVC_RAM_DCDC_VERR_HYST          = 1005,
SI3217X_REVC_RAM_DCDC_OITHRESH_LO        = 1006,
SI3217X_REVC_RAM_DCDC_OITHRESH_HI        = 1007,
SI3217X_REVC_RAM_HV_BIAS_ONHK            = 1008,
SI3217X_REVC_RAM_HV_BIAS_OFFHK           = 1009,
SI3217X_REVC_RAM_ILONG_RT_THRESH         = 1014,
SI3217X_REVC_RAM_VOV_RING_BAT_DCDC       = 1015,
SI3217X_REVC_RAM_LKG_LB_OFFSET           = 1017,
SI3217X_REVC_RAM_LKG_OFHK_OFFSET         = 1018,
SI3217X_REVC_RAM_SWEEP_FREQ_TH           = 1019,
SI3217X_REVC_RAM_AMP_MOD_G               = 1020,
SI3217X_REVC_RAM_AMP_MOD_OS              = 1021,
SI3217X_REVC_RAM_UNUSED_REG256           = 1280,
SI3217X_REVC_RAM_UNUSED_REG282           = 1306,
SI3217X_REVC_RAM_UNUSED_REG287           = 1311,
SI3217X_REVC_RAM_UNUSED_REG292           = 1316,
SI3217X_REVC_RAM_UNUSED_REG293           = 1317,
SI3217X_REVC_RAM_UNUSED_REG294           = 1318,
SI3217X_REVC_RAM_UNUSED_REG297           = 1321,
SI3217X_REVC_RAM_UNUSED_REG329           = 1353,
SI3217X_REVC_RAM_UNUSED_REG342           = 1366,
SI3217X_REVC_RAM_UNUSED_REG343           = 1367,
SI3217X_REVC_RAM_UNUSED_REG344           = 1368,
SI3217X_REVC_RAM_UNUSED_REG380           = 1404,
SI3217X_REVC_RAM_UNUSED_REG381           = 1405,
SI3217X_REVC_RAM_UNUSED_REG384           = 1408,
SI3217X_REVC_RAM_UNUSED_REG385           = 1409,
SI3217X_REVC_RAM_UNUSED_REG401           = 1425,
SI3217X_REVC_RAM_UNUSED_REG402           = 1426,
SI3217X_REVC_RAM_UNUSED_REG405           = 1429,
SI3217X_REVC_RAM_UNUSED_REG407           = 1431,
SI3217X_REVC_RAM_UNUSED_REG411           = 1435,
SI3217X_REVC_RAM_UNUSED_REG416           = 1440,
SI3217X_REVC_RAM_UNUSED_REG421           = 1445,
SI3217X_REVC_RAM_UNUSED_REG427           = 1451,
SI3217X_REVC_RAM_UNUSED_REG431           = 1455,
SI3217X_REVC_RAM_LKG_UPT_OHT             = 1464,
SI3217X_REVC_RAM_LKG_UPR_OHT             = 1465,
SI3217X_REVC_RAM_LKG_DNT_OHT             = 1466,
SI3217X_REVC_RAM_LKG_DNR_OHT             = 1467,
SI3217X_REVC_RAM_UNUSED_REG446           = 1470,
SI3217X_REVC_RAM_UNUSED_REG460           = 1484,
SI3217X_REVC_RAM_UNUSED_REG470           = 1494,
SI3217X_REVC_RAM_UNUSED_REG471           = 1495,
SI3217X_REVC_RAM_UNUSED_REG474           = 1498,
SI3217X_REVC_RAM_UNUSED_REG476           = 1500,
SI3217X_REVC_RAM_UNUSED_REG477           = 1501,
SI3217X_REVC_RAM_UNUSED_REG478           = 1502,
SI3217X_REVC_RAM_UNUSED_REG479           = 1503,
SI3217X_REVC_RAM_UNUSED_REG480           = 1504,
SI3217X_REVC_RAM_UNUSED_REG481           = 1505,
SI3217X_REVC_RAM_UNUSED_REG495           = 1519,
SI3217X_REVC_RAM_UNUSED_REG496           = 1520,
SI3217X_REVC_RAM_UNUSED_REG497           = 1521,
SI3217X_REVC_RAM_UNUSED_REG502           = 1526,
SI3217X_REVC_RAM_UNUSED_REG505           = 1529,
SI3217X_REVC_RAM_UNUSED_REG513           = 1537,
SI3217X_REVC_RAM_UNUSED_REG520           = 1544,
SI3217X_REVC_RAM_UNUSED_REG525           = 1549,
SI3217X_REVC_RAM_UNUSED_REG526           = 1550,
SI3217X_REVC_RAM_UNUSED_REG528           = 1552,
SI3217X_REVC_RAM_DCDC_CPUMP              = 1555,
SI3217X_REVC_RAM_UNUSED_REG532           = 1556,
SI3217X_REVC_RAM_UNUSED_REG535           = 1559,
SI3217X_REVC_RAM_UNUSED_REG538           = 1562,
SI3217X_REVC_RAM_UNUSED_REG542           = 1566,
SI3217X_REVC_RAM_UNUSED_REG543           = 1567,
SI3217X_REVC_RAM_UNUSED_REG548           = 1572,
SI3217X_REVC_RAM_UNUSED_REG569           = 1593,
SI3217X_REVC_RAM_UNUSED_REG570           = 1594,
SI3217X_REVC_RAM_JMP8                    = 1597,
SI3217X_REVC_RAM_JMP9                    = 1598,
SI3217X_REVC_RAM_JMP10                   = 1599,
SI3217X_REVC_RAM_JMP11                   = 1600,
SI3217X_REVC_RAM_JMP12                   = 1601,
SI3217X_REVC_RAM_JMP13                   = 1602,
SI3217X_REVC_RAM_JMP14                   = 1603,
SI3217X_REVC_RAM_JMP15                   = 1604,
SI3217X_REVC_RAM_METER_TRIG              = 1605,
SI3217X_REVC_RAM_PM_ACTIVE               = 1606,
SI3217X_REVC_RAM_PM_INACTIVE             = 1607,
SI3217X_REVC_RAM_HVIC_VERSION            = 1608,
SI3217X_REVC_RAM_THERM_OFF               = 1609,
SI3217X_REVC_RAM_THERM_HI                = 1610,
SI3217X_REVC_RAM_TEST_LOAD               = 1611,
SI3217X_REVC_RAM_DC_HOLD_MAN             = 1612,
SI3217X_REVC_RAM_DC_HOLD_DAC_MAN         = 1613,
SI3217X_REVC_RAM_UNUSED_REG590           = 1614,
SI3217X_REVC_RAM_DCDC_CPUMP_LP           = 1615,
SI3217X_REVC_RAM_DCDC_CPUMP_LP_MASK      = 1616,
SI3217X_REVC_RAM_DCDC_CPUMP_PULLDOWN     = 1617,
SI3217X_REVC_RAM_BOND_STATUS             = 1618,
SI3217X_REVC_RAM_BOND_MAN                = 1619,
SI3217X_REVC_RAM_BOND_VAL                = 1620,
SI3217X_REVC_RAM_REF_DEBOUNCE_PCLK       = 1633,
SI3217X_REVC_RAM_REF_DEBOUNCE_FSYNC      = 1634,
SI3217X_REVC_RAM_DCDC_LIFT_EN            = 1635,
SI3217X_REVC_RAM_DCDC_CPUMP_PGOOD        = 1636,
SI3217X_REVC_RAM_DCDC_CPUMP_PGOOD_WKEN   = 1637,
SI3217X_REVC_RAM_DCDC_CPUMP_PGOOD_FRC    = 1638,
SI3217X_REVC_RAM_DCDC_CPUMP_LP_MASK_SH   = 1639,
SI3217X_REVC_RAM_DCDC_UV_MAN             = 1640,
SI3217X_REVC_RAM_DCDC_UV_DEBOUNCE        = 1641,
SI3217X_REVC_RAM_DCDC_OV_MAN             = 1642,
SI3217X_REVC_RAM_DCDC_OV_DEBOUNCE        = 1643,
SI3217X_REVC_RAM_ANALOG3_TEST_MUX        = 1644,
};

#endif
